/**
 * JASMINe
 * Copyright (C) 2009-2010 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: Controller.as 8526 2011-07-12 07:01:20Z diorcety $
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.monitoring.eos.datamanagement.control
{
import com.adobe.cairngorm.control.CairngormEventDispatcher;

import flash.net.registerClassAlias;
    
    import com.adobe.cairngorm.control.FrontController;
    
    import org.ow2.jasmine.monitoring.eos.datamanagement.command.*;
    import org.ow2.jasmine.monitoring.eos.datamanagement.event.*;
	
	
	/**
     * Bind a type of command to an action.
	 * 
	 * An unique ID was added to all the events in order
	 * to prevent a Cairngorm issue: when a command event is dispatched,
	 * every controller that registered this event type receives it, even if
	 * located in another module. To prevent this from happening and triggering
	 * multiple severe unexpected concurrence bugs, each event dispatched is
	 * postfixed with this unique ID.
	 * 
	 * @author aydina
	 */
	public class Controller extends FrontController {
	
	    public function Controller(dispatcher: CairngormEventDispatcher) {
            super(dispatcher);
	    }

        public function initialiseCommands() : void {
	        this.addCommand(ConfigurePurgeTaskEvent.EVENT_CONFIGURE_PURGE_TASK, ConfigurePurgeTaskCommand);
            this.addCommand(ListPurgeTasksEvent.EVENT_LIST_PURGE_TASKS, ListPurgeTasksCommand);
            this.addCommand(RemovePurgeTaskEvent.EVENT_REMOVE_PURGE_TASK, RemovePurgeTaskCommand);
            this.addCommand(StartPurgeTaskEvent.EVENT_START_PURGE_TASK, StartPurgeTaskCommand);
            this.addCommand(PausePurgeTaskEvent.EVENT_PAUSE_PURGE_TASK, PausePurgeTaskCommand);
	    }

        public function removeCommands() : void {
	        this.removeCommand(ConfigurePurgeTaskEvent.EVENT_CONFIGURE_PURGE_TASK);
            this.removeCommand(ListPurgeTasksEvent.EVENT_LIST_PURGE_TASKS);
            this.removeCommand(RemovePurgeTaskEvent.EVENT_REMOVE_PURGE_TASK);
            this.removeCommand(StartPurgeTaskEvent.EVENT_START_PURGE_TASK);
            this.removeCommand(PausePurgeTaskEvent.EVENT_PAUSE_PURGE_TASK);
	    }
	}
}
