/**
 * JASMINe
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.monitoring.eos.datamanagement.view.components
{
    import mx.formatters.Formatter;
    
    /**
     * @author Francois Fornaciari
     */ 
    public class DayHourMinuteFormatter extends Formatter {
        
        public function DayHourMinuteFormatter() {
            super();
        }
        
        override public function format(value:Object):String {
            if (value == 0) {
                return "-";
            } else {
                var milliseconds:Number = value as Number;
                var days:int = milliseconds / (60 * 1000 * 24 * 60);
                var hours:int = (milliseconds % (60 * 1000 * 24 * 60)) / (60 * 60 * 1000);
                var minutes:int = ((milliseconds % (60 * 1000 * 24 * 60)) % (60 * 60 * 1000)) /  (60 * 1000);
                
                return(days + "d " + hours + "h " + minutes + "m");
            }
        }
    }
}